%global py3_shebang_flags %(echo %py3_shebang_flags | sed s/s//)
%global _description \
The Jupyter Notebook is a web application that allows you to create and \
share documents that contain live code, equations, visualizations, and \
explanatory text. The Notebook has support for multiple programming \
languages, sharing, and interactive widgets.

%bcond_with bootstrap

%if %{with bootstrap}
%bcond_with tests
%else
%bcond_without tests
%endif


# notebook roadmap is very aggressive, and we have to choose beta version
# to avoid update too much current package in our repo
# notebook -> jupyterlab -> python-requests python-jsonschema -> ...

Summary:        A web-based notebook environment for interactive computing
Name:           python-notebook
Version:        7.0.0b3
Release:        2%{?dist}
License:        BSD-3-Clause
URL:            https://jupyter.org
Source0:        %{pypi_source notebook}

BuildRequires:  python3-devel desktop-file-utils
BuildArch:      noarch

%description %_description

%package -n     python3-notebook
Summary:        A web-based notebook environment for interactive computing
Requires:       python-jupyter-filesystem

%description -n python3-notebook %_description

%prep
%autosetup -p1 -n notebook-%{version}

for pkg in nbval "selenium==.*" coverage pytest-cov pytest-tornasync; do
  sed -Ei "/\"$pkg\",?/d" pyproject.toml
done

# Remove all backup files
find ./ -name "*.json.orig" -delete

%generate_buildrequires
%pyproject_buildrequires %{?with_tests:-x test}


%build
%pyproject_wheel


%install
%pyproject_install
%pyproject_save_files notebook

install -m 0755 -p -d %{buildroot}%{_sysconfdir}/jupyter/jupyter_server_config.d
mv -v %{buildroot}{%{_prefix},}%{_sysconfdir}/jupyter/jupyter_server_config.d/notebook.json

%check
%if %{with tests}
%pytest -W ignore::DeprecationWarning --ignore notebook/tests/selenium

desktop-file-validate %{buildroot}%{_datadir}/applications/jupyter-notebook.desktop
%endif

%files -n python3-notebook -f %{pyproject_files}
%license LICENSE
%doc README.md
%{_bindir}/jupyter-notebook
%config(noreplace) %{_sysconfdir}/jupyter/jupyter_server_config.d/notebook.json
%{_datadir}/jupyter/lab/schemas/@jupyter-notebook/
%{_datadir}/jupyter/labextensions/@jupyter-notebook/
%{_datadir}/applications/jupyter-notebook.desktop
%{_datadir}/icons/hicolor/scalable/apps/notebook.svg

%changelog
* Fri Jun 28 2024 Shuo Wang <abushwang@tencent.com> - 7.0.0b3-2
- close bootstrap

* Fri Jun 14 2024 Shuo Wang <abushwang@tencent.com> - 7.0.0b3-1
- initial build
